!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Pseudo DOS/V Font/Display Driver for Fep Bridge 1.30
!	by Yutaka Tamiya (tamy@flab.fujitsu.co.jp) 1996/08/06
!	modified by Takeshi Sone (ts1@tsn.or.jp)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
.text

.globl _main
_main:		! for ld86

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Device Header
!	entry font driver of '$IBMAFNT'
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	.long	DispDevHeader	! link to the next driver
	.word	0x8000		! character device
	.word	Strategy	! strategy routine
	.word	Interrupt	! interrupt routine
	.ascii	"$IBMAFNT"	! device name

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Device Header
!	entry display driver of '$IBMADSP'
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DispDevHeader:
	.long	-1		! link to the next driver
	.word	0x8000		! character device
	.word	Strategy	! strategy routine
	.word	Interrupt	! interrupt routine
	.ascii	"$IBMADSP"	! device name

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Work Area
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PacketPtr:
	.long	0		! ptr of the request packet header
OrigInt15:
	.long	0		! ptr of the original int15h handler

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Strategy Routine
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Strategy:
	seg cs
	mov [PacketPtr], bx	! offset
	seg cs
	mov [PacketPtr+2], es	! segment
	retf

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Int 15h Handler
!	Int 15h / AX=4900h results in:
!	CF=0, AH=0, BL=0, if the system supports DOS/V Bios
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Int15Hook:
	cmp ax, #0x4900
	jnz Not4900

	push bp
	mov bp, sp
	and [bp+6], #0xfffe	! clear CF of flag reg. pushed on the stack
	mov bl, #0
	mov ah, #0
	pop bp
	iret
Not4900:
	seg cs
	jmpf [OrigInt15]

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Interrupt Routine
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Interrupt:
	pushf

	seg cs
	cmp [OrigInt15], #0
	jz Init

	popf
	retf

Init:
	push ax
	push bx
	push dx
	push ds
	push es

	mov ax, cs
	mov ds, ax

	! save original int 15h handler
	mov ax, #0
	mov es, ax
	seg es
	mov ax, [0x15*4]
	mov [OrigInt15], ax
	seg es
	mov ax, [0x15*4+2]
	mov [OrigInt15+2], ax

	! set new int 15h handler
	seg es
	mov [0x15*4], #Int15Hook	! entry Int15Hook
	seg es
	mov [0x15*4+2], cs

	! print message
	mov ah, #9
	mov dx, #Message
	int 0x21

	! save the end address
	lds bx, [PacketPtr]
	mov [bx+14], #Init
	mov [bx+14+2], cs
	mov [bx+3], #0x100	! no error status

	pop es
	pop ds
	pop dx
	pop bx
	pop ax
	popf
	retf

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Message String
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Message:
	.ascii	"Pseudo DOS/V Font/Display Driver ver. 1.20"
	.byte	0x0d, 0x0a
	.ascii	"        by Yutaka Tamiya (tamy@flab.fujitsu.co.jp)"
	.byte	0x0d, 0x0a
	.ascii	"$"
