;;;; $Id: fep-ime.el,v 1.13 1995/12/19 05:22:20 ueda Exp ueda $
;;;;
;; Fep server interface for Egg
;; Coded by Y.Ueda (ueda@kyoto-u.ac.jp)
;; Modified by Y. Tamiya (tamy@flab.fujitsu.co.jp) 1996/11/13

(require 'fep-egg)

;;; FEP dependent part for Microsoft MS-IME

;;; MS-IME$B<+?H$O!$%G%U%)%k%H$N@_Dj$G5/F0$9$k$h$&$K$7$F$/$@$5$$!%(B
;;; $BFC$K(B/J$B%*%W%7%g%s$G(B3$B0J>e$rM?$($J$$$h$&$K$7$F$/$@$5$$!%(B

;;;
;;; information about current bunsetu and kouho list attribute
;;;
(setq fep:*buf-attr-mask*     240)	; $B$3$$$D$H$N(Band$B$,!b(B0$B$G(B
(setq fep:*buf-attr-mask2*      0)	; $B$3$$$D$H$N(Band$B$,(B0$B$G$J$$$H$3$m$,8=J8@a(B
(setq fep:*system-attr-mask*  240)	; $B$3$$$D$H$N(Band$B$,!b(B0$B$N$H$3$m$,!$(B
					; $B8uJd0lMw$G%+!<%=%k$N$"$k8uJd(B

;;;
;;; FEP dependent primitive functions
;;;
;; $BJQ493+;O(B
(defun fep-henkan-begin ()
  (fep-next-kouho))

;; $BJQ493NDj(B
(defun fep-kakutei ()
  (fep-send-kcode (list ?M ?\C-M '(ctrl))))

;; $B8=J8@a$^$G$rJQ493NDj!J8=J8@a4^$`!K(B
(defun fep-bunsetu-kakutei ()
  (fep-send-kcode-list (list (list fep:VK_LEFT 0 nil)
			     (list fep:VK_DOWN 0 '(ctrl)))))

;; $B0l8D8e$NJ8@a$K0\F0$9$k(B
(defun fep-forward-bunsetu ()
  (fep-send-kcode (list fep:VK_DOWN 0 nil)))

;; $B0l8DA0$NJ8@a$K0\F0$9$k(B
(defun fep-backward-bunsetu ()
  (fep-send-kcode (list fep:VK_UP 0 nil)))

;; $B:G=i$NJ8@a$K0\F0$9$k(B
(defun fep-first-bunsetu ()
  (fep-send-kcode (list ?R ?\C-R '(ctrl))))

;; $B:G8e$NJ8@a$K0\F0$9$k(B
(defun fep-last-bunsetu ()
  (fep-send-kcode (list ?C ?\C-C '(ctrl))))

;; $B<!8uJd(B
(defun fep-next-kouho ()
  (fep-send-kcode (list fep:VK_CONVERT 0 nil)))

;; $BA08uJd(B
(defun fep-previous-kouho ()
  (fep-send-kcode (list fep:VK_CONVERT 0 '(shift))))

;; $BJ8@a$r0lJ8;z$N$P$9(B
(defun fep-bunsetu-nobasi ()
  (fep-send-kcode-list (list (list ?F ?\C-F '(ctrl))
			     (list fep:VK_CONVERT 0 nil))))
				; $B",J8@a$ND9$5$rJQ$($k%b!<%I$KF~$k$N$G85$KLa$9(B

;; $BJ8@a$r0lJ8;z=L$a$k(B
(defun fep-bunsetu-chijime ()
  (fep-send-kcode-list (list (list ?A ?\C-A '(ctrl))
			     (list fep:VK_CONVERT 0 nil))))
				; $B",J8@a$ND9$5$rJQ$($k%b!<%I$KF~$k$N$G85$KLa$9(B
  
;; $BJ8@a$r$R$i$,$J2=$9$k(B
(defun fep-bunsetu-hiragana ()
  (fep-send-kcode (list ?U ?\C-U '(ctrl))))

;; $BJ8@a$r%+%?%+%J2=$9$k(B
(defun fep-bunsetu-katakana ()
  (fep-send-kcode (list ?J ?\C-J '(ctrl))))

;; $B8uJd0lMw$r=PNO$9$k(B
(defun fep-kouho-list ()
  (fep-send-kcode-list (list (list fep:VK_CONVERT 0 nil)
			     (list fep:VK_CONVERT 0 '(shift)))))
				; $B",(B2$B2sJQ49$7$?$i0lMw$,=P$k@_Dj$K$J$C$F$$$k(B

;;; $B8uJd0lMwI=<(;~%3%^%s%I(B

;; $B8uJd0lMw$,=P$F$$$k>uBV$G0l$D8e$N0lMw$r=PNO$9$k(B
(defun fep-kouho-list-down ()
  (fep-send-kcode (list fep:VK_DOWN 0 '(shift))))

;; $B8uJd0lMw$,=P$F$$$k>uBV$G0l$DA0$N0lMw$r=PNO$9$k(B
(defun fep-kouho-list-up ()
  (fep-send-kcode (list fep:VK_UP 0 '(shift))))

;; $B8uJd0lMw$,=P$F$$$k>uBV$G<!$N8uJd$K0\F0$9$k(B
(defun fep-kouho-list-right ()
  (fep-send-kcode (list fep:VK_RIGHT 0 nil)))

;; $B8uJd0lMw$,=P$F$$$k>uBV$GA0$N8uJd$K0\F0$9$k(B
(defun fep-kouho-list-left ()
  (fep-send-kcode (list fep:VK_LEFT 0 nil)))

;; $B8uJd0lMw$,=P$F$$$k>uBV$G8=:_%+!<%=%k$N$"$k8uJd$rA*Br$9$k(B
;;	$B8uJd$,$J$$>l9g$O!$(Bnil$B$rJV$9!%(B
(defun fep-kouho-list-select ()
  (fep-send-kcode (list fep:VK_DOWN 0 nil))
  t)

;; $B8uJd0lMw$,=P$F$$$k>uBV$G(Bn$BHV$rA*Br$9$k(B
;;	$BF~NO$O(B`0'-`9'$B$G$9!%(B
;;	$B8uJd$,$J$$>l9g$O!$(Bnil$B$rJV$9!%(B
(defun fep-kouho-list-nth-kouho (ch)	; ch ?0 - ?9
  (if (string-match (concat (vector ch ?:)) fep:*system-str*)
      (progn
	(fep-send-kcode (list ch ch nil))
	t)
    nil))

;; $B8uJd0lMw$,=P$F$$$k>uBV$+$i8uJd$rA*Br$;$:$KH4$1$k(B
(defun fep-kouho-list-quit ()
  )					; $B2?$b$7$J$/$F$$$$(B
