;;;; $Id: fep-oak.el,v 1.13 1995/12/19 05:22:20 ueda Exp ueda $
;;;;
;; Fep server interface for Egg
;; Coded by Y.Ueda (ueda@kyoto-u.ac.jp)
;; Modified by Y. Tamiya (tamy@flab.fujitsu.co.jp) 1996/11/13

(require 'fep-egg)

;;; FEP dependent part for Fujitsu OAK/V

;;; OAK/V $B<+?H$N@_Dj$r0J2<$N$h$&$KJQ99$7$F$/$@$5$$!%(B
;;
;;  fjiae.def$B$G!$0J2<$N@_Dj$r$7$F$/$@$5$$!%(B
;;   [$BO@M}%-!<(B]
;;   $BL5JQ49(B1		@[F1]
;;   $BL5JQ49(B2		@[F2]
;;   [$BJQ49F0:n(B]
;;   $BJQ49>uBV(B		1
;;   $BA48uJd3MF@2s?t(B	0
;;   [$BJ8@aD{@5>uBV(B]
;;   $B%+!<%=%k1&(B		0
;;   [$BL$3NDjG[?'(B]
;;   $B8uJd$J$7(B		3
;;   $BL5JQ49(B		3
;;

;;; $BIT40A4$JE@$J$I(B
;;
;;  OAK/V$B$G$OJQ49$7$?7k2LJ8@a$,0l$D$K$J$C$F$7$^$C$?>l9g$K$O!$(B
;; $B%-!<%P%$%s%I$,O"J8@a$N$H$-$H0[$J$k$h$&$G!$(B
;; $BJ8@a$r=L$a$FJ,3d$9$k$3$H$,$G$-$^$;$s!%(B
;;  $B$^$?!$(BOAK/V$B$G$O%j%9%H%\%C%/%9$H$$$&JL$N%$%s%?%U%'!<%9$rMQ0U$7$F$$$k$?$a$+!$(B
;; $B8uJd0lMw5!G=$,IO<e$G$9!%$=$N$?$a!$0J2<$N$h$&$J@)8B$,$"$j$^$9!%(B
;; $B!&8uJd0lMw%b!<%I$G8uJd$r%+!<%=%k:81&$GA*$V$3$H$,$G$-$J$$!%(B
;; $B!&8uJd0lMw$rI=<($7$?=V4V$K!$3:EvJ8@a$,L5JQ49>uBV$K$J$C$F$7$^$&$h$&$G!$(B
;;   $B8uJd0lMw>uBV$N$H$-$K(B\C-g$B$J$I$GH4$1$?$H$-$K!$(B
;;   $B3:EvJ8@a$O!$0lMwI=<(A0$N>uBV$G$O$J$/!$L5JQ49(B($B$+$J(B)$B>uBV$K$J$C$F$7$^$$$^$9!%(B
;; $B0J>e$NLdBj$K$D$$$F2r7hK!$,$"$l$P65$($F$/$@$5$$!%(B

;;;
;;; information about current bunsetu and kouho list attribute
;;;
(setq fep:*buf-attr-mask*      32)	; $B$3$$$D$H$N(Band$B$,!b(B0$B$G(B
(setq fep:*buf-attr-mask2*    128)	; $B$3$$$D$H$N(Band$B$,(B0$B$G$J$$$H$3$m$,8=J8@a(B
(setq fep:*system-attr-mask*    0)	; $B$3$$$D$H$N(Band$B$,!b(B0$B$N$H$3$m$,!$(B
					; $B8uJd0lMw$G%+!<%=%k$N$"$k8uJd(B

;;;
;;; FEP dependent primitive functions
;;;
;; $BJQ493+;O(B
(defun fep-henkan-begin ()
  (fep-next-kouho))

;; $BJQ493NDj(B
(defun fep-kakutei ()
  (fep-send-kcode (list ?M ?\C-M '(ctrl))))

;; $B8=J8@a$^$G$rJQ493NDj!J8=J8@a4^$`!K(B
(defun fep-bunsetu-kakutei ()
  (fep-send-kcode-list (list (list fep:VK_LEFT 0 nil)
			     (list fep:VK_RETURN 0 '(shift)))))

;; $B0l8D8e$NJ8@a$K0\F0$9$k(B
(defun fep-forward-bunsetu ()
  (fep-send-kcode (list fep:VK_RIGHT 0 nil)))

;; $B0l8DA0$NJ8@a$K0\F0$9$k(B
(defun fep-backward-bunsetu ()
  (fep-send-kcode (list fep:VK_LEFT 0 nil)))

;; $B:G=i$NJ8@a$K0\F0$9$k(B
(defun fep-first-bunsetu ()
  (fep-send-kcode (list fep:VK_HOME 0 nil)))

;; $B:G8e$NJ8@a$K0\F0$9$k(B
(defun fep-last-bunsetu ()
  (fep-send-kcode (list fep:VK_END 0 nil)))

;; $B<!8uJd(B
(defun fep-next-kouho ()
  (fep-send-kcode (list fep:VK_CONVERT 0 nil)))

;; $BA08uJd(B
(defun fep-previous-kouho ()
  (fep-send-kcode (list fep:VK_CONVERT 0 '(shift))))

;; $BJ8@a$r0lJ8;z$N$P$9(B
(defun fep-bunsetu-nobasi ()
  (fep-send-kcode (list fep:VK_RIGHT 0 '(shift))))

;; $BJ8@a$r0lJ8;z=L$a$k(B
(defun fep-bunsetu-chijime ()
  (fep-send-kcode (list fep:VK_LEFT 0 '(shift))))
  
;; $BJ8@a$r$R$i$,$J2=$9$k(B
(defun fep-bunsetu-hiragana ()
  (fep-send-kcode (list fep:VK_F2 0 '(meta))))

;; $BJ8@a$r%+%?%+%J2=$9$k(B
(defun fep-bunsetu-katakana ()
  (fep-send-kcode-list (list (list fep:VK_F2 0 '(meta))
			     (list fep:VK_F1 0 '(meta))
			     (list fep:VK_F1 0 '(meta)))))

;; $B8uJd0lMw$r=PNO$9$k(B
(defun fep-kouho-list ()
  (fep-send-kcode (list fep:VK_CONVERT 0 '(meta))))

;;; $B8uJd0lMwI=<(;~%3%^%s%I(B

;; $B8uJd0lMw$,=P$F$$$k>uBV$G0l$D8e$N0lMw$r=PNO$9$k(B
(defun fep-kouho-list-down ()
  (fep-send-kcode (list fep:VK_DOWN 0 nil)))

;; $B8uJd0lMw$,=P$F$$$k>uBV$G0l$DA0$N0lMw$r=PNO$9$k(B
(defun fep-kouho-list-up ()
  (fep-send-kcode (list fep:VK_UP 0 nil)))

;; $B8uJd0lMw$,=P$F$$$k>uBV$G<!$N8uJd$K0\F0$9$k(B
(defun fep-kouho-list-right ()
  (beep))				; $B5!G=$J$7!)(B

;; $B8uJd0lMw$,=P$F$$$k>uBV$GA0$N8uJd$K0\F0$9$k(B
(defun fep-kouho-list-left ()
  (beep))				; $B5!G=$J$7!)(B

;; $B8uJd0lMw$,=P$F$$$k>uBV$G8=:_%+!<%=%k$N$"$k8uJd$rA*Br$9$k(B
;;	$B8uJd$,$J$$>l9g$O!$(Bnil$B$rJV$9!%(B
(defun fep-kouho-list-select ()
  nil)					; $B5!G=$J$7!)(B

;; $B8uJd0lMw$,=P$F$$$k>uBV$G(Bn$BHV$rA*Br$9$k(B
;;	$BF~NO$O(B`0'-`9'$B$G$9!%(B
;;	$B8uJd$,$J$$>l9g$O!$(Bnil$B$rJV$9!%(B
(defun fep-kouho-list-nth-kouho (ch)	; ch ?0 - ?9
  (if (string-match (concat (vector ch ?:)) fep:*system-str*)
      (progn
	(fep-send-kcode (list ch ch nil))
	t)
    nil))

;; $B8uJd0lMw$,=P$F$$$k>uBV$+$i8uJd$rA*Br$;$:$KH4$1$k(B
(defun fep-kouho-list-quit ()
  (fep-send-kcode (list fep:VK_F1 0 '(meta))) ; $BL5JQ49$G$7$+H4$1$l$J$$!)(B
  (setq changed t))	; $BJQ49J8;zNs$,0lMwA0$N>uBV$H$OJQ$o$C$F$7$^$&!%(B
			; changed$B$O(Bhenkan-select-kouho () $B$N%m!<%+%kJQ?t(B
