/*
  Fep.h : I/F of FEP Bridge 1.30
    Copyright (C) Yutaka Tamiya (tamy@flab.fujitsu.co) 1996/08/06
 */
/*
 * Copyright (c) 1990  Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * Author:  Makoto Ishisone, Software Research Associates, Inc., Japan
 */

/* Copyright 1991 NEC Corporation, Tokyo, Japan.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of NEC Corporation
 * not be used in advertising or publicity pertaining to distribution
 * of the software without specific, written prior permission.  NEC 
 * Corporation makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express
 * or implied warranty.
 *
 * NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
 * NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
 * OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 *
 * Author: Akira Kon, NEC Corporation.  (kon@d1.bs2.mt.nec.co.jp)
 */

#ifndef _Fep_h
#define _Fep_h

#include "InputConv.h"

/*
  Fep new resources:

  name			class		      type    default	      access
  ----------------------------------------------------------------------------
  conversionEndKeys	ConversionEndKeys     String  Shift<Key>space	CG
  fepHost		FepHost     	      String  NULL		CG
  hankakuKanaToZenkaku	HankakuKanaToZenkaku  Boolean False		CG
  zenkakuAsciiToHankaku	ZenkakuAsciiToHankaku Boolean False		CG
  alwaysShowSystemStr	AlwaysShowSystemStr   Boolean False		CG
  bufAttrMask		BufAttrMask	      Int     0xf0		CG
  systemAttrMask	SystemAttrMask	      Int     0xf0		CG
  swapBackDeleteKeys	SwapBackDeleteKeys    Boolean False		CG
*/

#define	XtNconversionEndKeys		"conversionEndKeys"
#define	XtCConversionEndKeys		"ConversionEndKeys"
#define	XtNfepHost			"fepHost"
#define	XtCFepHost			"FepHost"
#define	XtNhankakuKanaToZenkaku		"hankakuKanaToZenkaku"
#define	XtCHankakuKanaToZenkaku		"HankakuKanaToZenkaku"
#define	XtNzenkakuAsciiToHankaku	"zenkakuAsciiToHankaku"
#define	XtCZenkakuAsciiToHankaku	"ZenkakuAsciiToHankaku"
#define	XtNalwaysShowSystemStr		"alwaysShowSystemStr"
#define	XtCAlwaysShowSystemStr		"AlwaysShowSystemStr"
#define	XtNbufAttrMask			"bufAttrMask"
#define	XtCBufAttrMask			"BufAttrMask"
#define	XtNsystemAttrMask		"systemAttrMask"
#define	XtCSystemAttrMask		"SystemAttrMask"
#define	XtNswapBackDeleteKeys		"swapBackDeleteKeys"
#define	XtCSwapBackDeleteKeys		"SwapBackDeleteKeys"

typedef struct _FepClassRec	*FepObjectClass;
typedef struct _FepRec	*FepObject;

extern WidgetClass	fepObjectClass;

#endif /* _Fep_h */

