/*
  FepP.h  : I/F of FEP Bridge 1.30
    Copyright (C) Yutaka Tamiya (tamy@flab.fujitsu.co) 1996/08/06
 */
/*
 * Copyright (c) 1990  Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * Author:  Makoto Ishisone, Software Research Associates, Inc., Japan
 */

/* Copyright 1991 NEC Corporation, Tokyo, Japan.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of NEC Corporation
 * not be used in advertising or publicity pertaining to distribution
 * of the software without specific, written prior permission.  NEC 
 * Corporation makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express
 * or implied warranty.
 *
 * NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
 * NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
 * OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 *
 * Author: Akira Kon, NEC Corporation. (kon@d1.bs2.mt.nec.co.jp)
 */

#ifndef _FepP_h
#define _FepP_h

#include "InputConvP.h"

#include "WStr.h"
#include "Fep.h"
#include "feplib.h"

/*
  Conversion End Key Spec.
*/
typedef struct {
    KeySym	keysym;
    long	modifiers;
    long	check_modifiers;
} FepTriggerKey;

/*
  Fep Class Part
*/
typedef struct {
    FepResult	Result;		/* Result from FEP Bridge		*/
    Boolean	ShowSystemStr;	/* Flag to show System string 	*/
    /* Segment Info of Mode, System, and Buf */
    int		NumModeSeg;	/* # of segments of ModeStr		*/
    int*	IndexModeSeg;	/* index of segments of ModeStr		*/
    int		NumSystemSeg;	/* # of segments of SystemStr		*/
    int*	IndexSystemSeg;	/* index of segments of SystemStr	*/
    int		NumBufSeg;	/* # of segments of BufStr		*/
    int*	IndexBufSeg;	/* index of segments of BufStr		*/
    wchar*	PrevModeStr;	/* previous gotten ModeStr		*/
} FepClassPart;

typedef struct _FepClassRec {
    ObjectClassPart object_class;
    InputConvClassPart inputConv_class;
    FepClassPart fep_class;
} FepClassRec;

typedef struct {
/* resources */
    String	FepHost;	/* Fep Bridge Network Host		*/
    String	ConvEndKeysStr;	/* Conversion End Keys String		*/
    Boolean	KanaHanToZen;	/* Flag to convert hankaku kana to zenkaku */
    Boolean	AsciiZenToHan;	/* Flag to convert zenkaku ascii to hankaku */
    Boolean	AlwaysShowSystemStr;	/* Flag always to show System string */
    int		BufAttrMask;	/* Mask pattern of BufAttr to highlight */
    int		SystemAttrMask;	/* Mask pattern of SystemAttr to highlight */
    Boolean	SwapBackDeleteKeys;	/* Swap BackSpace & Delete keys ? */
/* private data */
    int		NumConvEndKeys;	/* # of conversion end keys		*/
    FepTriggerKey	*ConvEndKeys;	/* array of conversion end keys	*/
    int		ConvFlags;	/* bit-wise conversion flags */
} FepPart;

typedef struct _FepRec {
    ObjectPart  object;
    InputConvPart inputConv;
    FepPart fep;
} FepRec;

#endif
