;;;
;;; fepkeys.el: Key bindings for non X11 terminal([kx]term)
;;;	for Fep Bridge 1.30 (1996/08/06)
;;;	Copyright (C) Yutaka Tamiya (tamy@flab.fujitsu.co.jp)

(defvar fep:*esc-map* (make-keymap))
(fset 'fep:esc-prefix fep:*esc-map*)
(define-key fep:*mode-map* "\e" 'fep:esc-prefix)

(define-key fep:*esc-map* "[2~" 'fep:key-insert)	; [insert]
(define-key fep:*esc-map* "[3~" 'fep:key-delete)	; [delete]
(define-key fep:*esc-map* "[4~" 'fep:key-select)	; [select]
(define-key fep:*esc-map* "[5~" 'fep:key-prior)		; [prior]
(define-key fep:*esc-map* "[6~" 'fep:key-next)		; [next]

(define-key fep:*esc-map* "OA" 'fep:key-noshift-up)	; [up]
(define-key fep:*esc-map* "OB" 'fep:key-noshift-down)	; [down]
(define-key fep:*esc-map* "OC" 'fep:key-noshift-right)	; [right]
(define-key fep:*esc-map* "OD" 'fep:key-noshift-left)	; [left]
(define-key fep:*esc-map* "[A" 'fep:key-noshift-up)	; [up]
(define-key fep:*esc-map* "[B" 'fep:key-noshift-down)	; [down]
(define-key fep:*esc-map* "[C" 'fep:key-noshift-right)	; [right]
(define-key fep:*esc-map* "[D" 'fep:key-noshift-left)	; [left]
(define-key fep:*esc-map* "[E" 'fep:key-shift-up)	; [up]
(define-key fep:*esc-map* "[F" 'fep:key-shift-down)	; [down]
(define-key fep:*esc-map* "[G" 'fep:key-shift-right)	; [right]
(define-key fep:*esc-map* "[H" 'fep:key-shift-left)	; [left]
(define-key fep:*esc-map* "[I" 'fep:key-control-up)	; [up]
(define-key fep:*esc-map* "[J" 'fep:key-control-down)	; [down]
(define-key fep:*esc-map* "[K" 'fep:key-control-right)	; [right]
(define-key fep:*esc-map* "[L" 'fep:key-control-left)	; [left]

(define-key fep:*esc-map* "[11~" 'fep:key-f1)	; F1
(define-key fep:*esc-map* "[12~" 'fep:key-f2)	; F2
(define-key fep:*esc-map* "[13~" 'fep:key-f3)  	; F3
(define-key fep:*esc-map* "[14~" 'fep:key-f4)	; F4
(define-key fep:*esc-map* "[15~" 'fep:key-f5)	; F5
(define-key fep:*esc-map* "[[A" ' fep:key-f1)	; F1
(define-key fep:*esc-map* "[[B"  'fep:key-f2)	; F2
(define-key fep:*esc-map* "[[C"  'fep:key-f3)  	; F3
(define-key fep:*esc-map* "[[D"  'fep:key-f4)	; F4
(define-key fep:*esc-map* "[[E"  'fep:key-f5)	; F5
(define-key fep:*esc-map* "[17~" 'fep:key-f6)	; F6
(define-key fep:*esc-map* "[18~" 'fep:key-f7)	; F7
(define-key fep:*esc-map* "[19~" 'fep:key-f8)	; F8
(define-key fep:*esc-map* "[20~" 'fep:key-f9)	; F9
(define-key fep:*esc-map* "[21~" 'fep:key-f10)	; F10

(define-key fep:*esc-map* "[23~" 'fep:key-f11)	; F11 or         L1
(define-key fep:*esc-map* "[24~" 'fep:key-f12)	; F12 or         L2
(define-key fep:*esc-map* "[25~" 'fep:key-f13)	; F13 or         L3
(define-key fep:*esc-map* "[26~" 'fep:key-f14)	; F14 or         L4
(define-key fep:*esc-map* "[28~" 'fep:key-f15)	; F15 or Help or L5
(define-key fep:*esc-map* "[29~" 'fep:key-f16)	; F16 or Menu or L6
(define-key fep:*esc-map* "[31~" 'fep:key-f17)	; F17 or         L7
(define-key fep:*esc-map* "[32~" 'fep:key-f18)	; F18 or         L8
(define-key fep:*esc-map* "[33~" 'fep:key-f19)	; F19 or         L9
(define-key fep:*esc-map* "[34~" 'fep:key-f20)	; F20 or         L10

(defun fep:key-noshift-left ()
  (interactive "*")
  (fep:conv (list fep:VK_LEFT 0 '())))

(defun fep:key-noshift-up ()
  (interactive "*")
  (fep:conv (list fep:VK_UP 0 '())))

(defun fep:key-noshift-right ()
  (interactive "*")
  (fep:conv (list fep:VK_RIGHT 0 '())))

(defun fep:key-noshift-down ()
  (interactive "*")
  (fep:conv (list fep:VK_DOWN 0 '())))

(defun fep:key-shift-left ()
  (interactive "*")
  (fep:conv (list fep:VK_LEFT 0 '(shift))))

(defun fep:key-shift-up ()
  (interactive "*")
  (fep:conv (list fep:VK_UP 0 '(shift))))

(defun fep:key-shift-right ()
  (interactive "*")
  (fep:conv (list fep:VK_RIGHT 0 '(shift))))

(defun fep:key-shift-down ()
  (interactive "*")
  (fep:conv (list fep:VK_DOWN 0 '(shift))))

(defun fep:key-control-left ()
  (interactive "*")
  (fep:conv (list fep:VK_LEFT 0 '(control))))

(defun fep:key-control-up ()
  (interactive "*")
  (fep:conv (list fep:VK_UP 0 '(control))))

(defun fep:key-control-right ()
  (interactive "*")
  (fep:conv (list fep:VK_RIGHT 0 '(control))))

(defun fep:key-control-down ()
  (interactive "*")
  (fep:conv (list fep:VK_DOWN 0 '(control))))
